﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace invoice_manager
{
    /// <summary>
    /// Trida Item (Položka) slouží pro reprezentaci jedné položky na faktruře
    /// </summary>
    public class Item
    {

        private int id;
        //slovní popis položky
        private String description;
        //množství
        private int quantity;
        //cena za jednotku
        private int pricePerQ;
        //celková cena
        private int price;

        public Item(int id)
        {
            this.id = id;
        }

        public Item(int id, String desc) 
            : this(id, desc, 0, 0)
        {
        }

        public Item(int id, String desc, int quantity, int pricePerQuantity)
        {
            this.id = id;
            this.description = desc;
            this.quantity = quantity;
            this.pricePerQ = pricePerQuantity;
            this.price = this.quantity * this.pricePerQ;
        }

        /// <value>
        /// ID položky
        /// </value>
        public int ID
        {
            get { return id; }
            set { id = value; }
        }

        /// <value>
        /// Slovní popis účtované služby
        /// </value>
        public String Description
        {
            get { return description; }
            set { description = value; }
        }

        /// <value>
        /// Počet jednotek služby
        /// </value>
        public int Quantity
        {
            get { return quantity; }
            set { quantity = value; }
        }

        /// <value>
        /// Cena za jednotku služby
        /// </value>
        public int PricePerQ
        {
            get { return pricePerQ; }
            set { pricePerQ = value; }
        }

        /// <value>
        /// Cena za celou službu
        /// </value>
        public int Price
        {
            get { return price; }
            set { price = value; }
        }

        //metody

        public string toSave()
        {
            return ""+id+"|"+description+"|"+quantity+"|"+pricePerQ;
        }

        public override string ToString()
        {
            return "Item: " + id + " " + description + " " + quantity + " x " + pricePerQ + " = " + price;
        }

        public override bool Equals(object obj)
        {
            if (this.GetHashCode() == obj.GetHashCode())
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        public override int GetHashCode()
        {
            return this.id;
        }
    }
}
