﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace invoice_manager
{
    class IssuedMenu
    {
        public static void menu()
        {
            Dictionary<char, MenuItem> submenu = new Dictionary<char, MenuItem>();
            submenu.Add('1', new MenuItem() { fce = new fce(createIssued), desc = "Vytvořit" });
            submenu.Add('2', new MenuItem() { fce = new fce(writeAllIssued), desc = "Vypsat" });
            submenu.Add('3', new MenuItem() { fce = new fce(editIssuedById), desc = "Upravit" });
            submenu.Add('4', new MenuItem() { fce = new fce(addIssuedItem), desc = "Přidat položku" });
            submenu.Add('5', new MenuItem() { fce = new fce(findIssuedById), desc = "Zobrazit" });
            submenu.Add('6', new MenuItem() { fce = new fce(findIssuedNotPaid), desc = "Zobrazit nezaplacené" });
            submenu.Add('7', new MenuItem() { fce = new fce(paidIssued), desc = "Označit jako zaplacenou" });
            submenu.Add('8', new MenuItem() { fce = new fce(delIssuedById), desc = "Smazat podle ID" });
            submenu.Add('*', new MenuItem() { fce = new fce(Program.Return), desc = "Return" });
            submenu.Add('0', new MenuItem() { fce = new fce(Program.Exit), desc = "Konec" });

            while (true)
            {
                foreach (KeyValuePair<char, MenuItem> polozka in submenu)
                {
                    Console.WriteLine("[" + polozka.Key + "] - " + polozka.Value.desc);
                }
                string volba = Console.ReadLine();
                if (submenu.ContainsKey(volba[0]))
                    submenu[volba[0]].fce();
            }
        }

        public static void createIssued()
        {
            String s;
            Invoice newInvoice;

            bool contain, wrongInt = false;
            do
            {
                Console.WriteLine("Zadejte ID: ");
                s = Console.ReadLine();
                int i;
                wrongInt = (i = toInt(s)) == int.MinValue ?  true : false;
                if (wrongInt)
                {
                    Console.WriteLine("Zadejte číslo.");
                }

                newInvoice = new Invoice(i);
                contain = Program.issuedInvoices.Contains(newInvoice);
                if (contain)
                {
                    Console.WriteLine("Faktura s tímto ID již existuje.");
                }
            } while (String.IsNullOrEmpty(s) || contain || wrongInt);

            do
            {
                Console.WriteLine("Počet dní do splatnosti: ");
                s = Console.ReadLine();
                int i;
                wrongInt = (i = toInt(s)) == int.MinValue ? true : false;
                if (wrongInt)
                {
                    Console.WriteLine("Zadejte číslo.");
                }
                newInvoice.setDueDate = i;
            } while (String.IsNullOrEmpty(s) || wrongInt);

            Person finded;
            do
            {
                Console.WriteLine("Zadejte ID dodavatele: ");
                s = Console.ReadLine();
                int i;
                wrongInt = (i = toInt(s)) == int.MinValue ? true : false;
                if (wrongInt)
                {
                    Console.WriteLine("Zadejte číslo.");
                }
                finded = findPersonById(i);
                if (finded != null)
                {
                    newInvoice.Supplier = finded;
                }
                else
                {
                    Console.WriteLine("Dodavatel nenalezen.");
                }
                
            } while (String.IsNullOrEmpty(s) || wrongInt || finded == null);

            do
            {
                Console.WriteLine("Zadejte ID odběratele: ");
                s = Console.ReadLine();
                int i;
                wrongInt = (i = toInt(s)) == int.MinValue ? true : false;
                if (wrongInt)
                {
                    Console.WriteLine("Zadejte číslo.");
                }
                finded = findPersonById(i);
                if (finded != null)
                {
                    newInvoice.Subscriber = finded;
                }
                else
                {
                    Console.WriteLine("Odběratel nenalezen.");
                }

            } while (String.IsNullOrEmpty(s) || wrongInt || finded == null);


            if (!Program.issuedInvoices.Contains(newInvoice))
            {
                Program.issuedInvoices.Add(newInvoice);
            }
        }

        public static void writeAllIssued()
        {
            Console.WriteLine("---------------------------------------");
            if (Program.issuedInvoices.Count == 0)
                Console.WriteLine("Žádné položky v seznamu.");
            else
                Program.issuedInvoices.ForEach(Console.WriteLine);
            Console.WriteLine("---------------------------------------");
        }

        public static void findIssuedById()
        {
            Console.WriteLine("Zadejte ID hledané faktury:");
            int i = toInt(Console.ReadLine());
            Invoice result = findInvoiceById(i);
            if (result != null)
            {
                Console.WriteLine("---------------------------------------");
                Console.WriteLine("Faktura - ID: {0}; zaplacena: {1}", result.ID, result.Paid);
                Console.WriteLine("Dodavatel: {0}", result.Supplier.ToString());
                Console.WriteLine("Odberatel: {0}", result.Subscriber.ToString());
                Console.WriteLine("Datum vystavení: {0}; datum splatnosti: {1}", result.Created, result.DueDate);
                foreach(Item item in result.Items)
                {
                    Console.WriteLine(item.ToString());
                }
                Console.WriteLine("---------------------------------------");
            }
            else
            {
                Console.WriteLine("Faktura s ID {0} nenalezena.", i);
            }
        }

        public static void addIssuedItem()
        {
            Console.WriteLine("Zadejte ID faktury ke které chce přidat položku:");
            int i = toInt(Console.ReadLine());
            Invoice result = findInvoiceById(i);
            if (result != null)
            {
                Console.WriteLine("Zadejte položku ve tvaru: (QUIT pro konec)");
                Console.WriteLine("ID POPIS POČET_KUSŮ CENA_ZA_KUS - vše oddělené mezerami.");
                String input;
                while (!(input = Console.ReadLine()).Equals("QUIT", StringComparison.InvariantCultureIgnoreCase))
                {
                    String[] s = input.Split(' ');
                    if (s.Length == 4)
                    {
                        //TO-DO: ošetřit zadávání špatných datových typů
                        Item newItem = new Item(toInt(s[0]), s[1], toInt(s[2]), toInt(s[3]));
                        result.addItem(newItem);
                    }
                    else
                    {
                        Console.WriteLine("Špatný počet argumentů");
                    }
                }
            }
            else
            {
                Console.WriteLine("Faktura s ID {0} nenalezena.", i);
            }
        }

        public static void editIssuedById()
        {
            Console.WriteLine("Zadejte ID faktury kterou chcete upravit:");
            int i = toInt(Console.ReadLine());
            Invoice result = findInvoiceById(i);
            if (result != null)
            {
                //TO-DO: Dodělat možnost upravit
                Console.WriteLine("Možnost úprav zatím není dostupná.");
            }
            else
            {
                Console.WriteLine("Faktura s ID {0} nenalezena.", i);
            }
        }

        public static void findIssuedNotPaid()
        {
            Console.WriteLine("---------------------------------------");
            foreach (Invoice inv in Program.issuedInvoices)
            {
                if (!inv.Paid)
                    Console.WriteLine(inv.ToString());
            }
            Console.WriteLine("---------------------------------------");
        }

        public static void paidIssued()
        {
            Console.WriteLine("Zadejte ID faktury která byla zaplacena:");
            int i = toInt(Console.ReadLine());
            Invoice result = findInvoiceById(i);
            if (result != null)
            {
                result.Paid = true;
                Console.WriteLine("Faktura {0} byla označena jako zaplacená.", result.ID);
            }
            else
            {
                Console.WriteLine("Faktura s ID {0} nenalezena.", i);
            }  
        }

        public static void delIssuedById()
        {
            Console.WriteLine("Zadejte ID faktury kterou chcete smazat:");
            int i = toInt(Console.ReadLine());
            Invoice result = findInvoiceById(i);
            if (result != null)
            {
                if (Program.issuedInvoices.Remove(result))
                {
                    Console.WriteLine("Faktura {0} smazána.", result.ToString());
                }
            }
            else
            {
                Console.WriteLine("Faktura s ID {0} nenalezena.", i);
            }
            
        }

        public static int toInt(String s)
        {
            int i = int.MinValue;
            try
            {
                i = Convert.ToInt32(s);
            }
            catch (FormatException e)
            {
                Console.WriteLine("Error: Input string is not a sequence of digits.");
            }
            catch (OverflowException e)
            {
                Console.WriteLine("Error: The number cannot fit in an Int32.");
            }
            return i;
        }

        /// <summary>
        /// Metoda najde osobu (Person) podle jejiho ID (IČ)
        /// </summary>
        public static Person findPersonById(int id)
        {
            Person finded = Program.people.Find(
            delegate(Person p)
            {
                return p.CompanyId == id;
            }
            );
            return finded;
        }

        /// <summary>
        /// Metoda najde fakturu (Invoice) podle jejiho ID (IČ)
        /// </summary>
        public static Invoice findInvoiceById(int id)
        {
            Invoice finded = Program.issuedInvoices.Find(
            delegate(Invoice inv)
            {
                return inv.ID == id;
            }
            );
            return finded;
        }

    }
}
