﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace invoice_manager
{
    class ItemMenu
    {
        public static void menu()
        {
            Dictionary<char, MenuItem> submenu = new Dictionary<char, MenuItem>();
            submenu.Add('1', new MenuItem() { fce = new fce(createItem), desc = "Vytvořit" });
            submenu.Add('2', new MenuItem() { fce = new fce(writeAllItem), desc = "Vypsat" });
            submenu.Add('3', new MenuItem() { fce = new fce(editItemById), desc = "Upravit" });
            submenu.Add('4', new MenuItem() { fce = new fce(findItemById), desc = "Najít podle ID" });
            submenu.Add('5', new MenuItem() { fce = new fce(delitemById), desc = "Smazat podle ID" });
            submenu.Add('*', new MenuItem() { fce = new fce(Program.Return), desc = "Return" });
            submenu.Add('0', new MenuItem() { fce = new fce(Program.Exit), desc = "Konec" });

            while (true)
            {
                foreach (KeyValuePair<char, MenuItem> polozka in submenu)
                {
                    Console.WriteLine("[" + polozka.Key + "] - " + polozka.Value.desc);
                }
                string volba = Console.ReadLine();
                if (submenu.ContainsKey(volba[0]))
                    submenu[volba[0]].fce();
            }
        }

        public static void createItem()
        {
            String s;
            Item newItem;

            bool contain, wrongInt = false;
            do
            {
                Console.WriteLine("Zadejte ID: ");
                s = Console.ReadLine();
                int i;
                wrongInt = (i = toInt(s)) == int.MinValue ?  true : false;
                if (wrongInt)
                {
                    Console.WriteLine("Zadejte číslo.");
                }

                newItem = new Item(i);
                contain = Program.items.Contains(newItem);
                if (contain)
                {
                    Console.WriteLine("Položka s tímto ID již existuje.");
                }
            } while (String.IsNullOrEmpty(s) || contain || wrongInt);

            do
            {
                Console.WriteLine("Zadej popis: ");
                s = Console.ReadLine();
                newItem.Description = s;
            } while(String.IsNullOrEmpty(s));

            do
            {
                Console.WriteLine("Zadej počet kusů: ");
                s = Console.ReadLine();
                int i;
                wrongInt = (i = toInt(s)) == int.MinValue ? true : false;
                if (wrongInt)
                {
                    Console.WriteLine("Zadejte číslo.");
                }
                newItem.Quantity = i;
            } while (String.IsNullOrEmpty(s) || wrongInt);

            do
            {
                Console.WriteLine("Zadej cenu: ");
                s = Console.ReadLine();
                int i;
                wrongInt = (i = toInt(s)) == int.MinValue ? true : false;
                if (wrongInt)
                {
                    Console.WriteLine("Zadejte číslo.");
                }
                newItem.PricePerQ = i;
            } while (String.IsNullOrEmpty(s) || wrongInt);

            newItem.Price = newItem.Quantity * newItem.PricePerQ;

            if (!Program.items.Contains(newItem))
            {
                Program.items.Add(newItem);
            }
        }

        public static void writeAllItem()
        {
            Console.WriteLine("---------------------------------------");
            if (Program.items.Count == 0)
                Console.WriteLine("Žádné položky v seznamu.");
            else
                Program.items.ForEach(Console.WriteLine);
            Console.WriteLine("---------------------------------------");
        }

        public static void findItemById()
        {
            Console.WriteLine("Zadejte ID hledané položky:");
            int i = toInt(Console.ReadLine());
            Item result = findById(i);
            if (result != null)
            {
                Console.WriteLine(result.ToString());   
            }
            else
            {
                Console.WriteLine("Pložka s ID {0} nenalezena.", i);
            }
        }

        public static void editItemById()
        {
            Console.WriteLine("Zadejte ID Položky kterou chcete upravit:");
            int i = toInt(Console.ReadLine());
            Item result = findById(i);
            if (result != null)
            {
                //TO-DO: Dodělat možnost upravit
                Console.WriteLine("Možnost úprav zatím není dostupná.");
            }
            else
            {
                Console.WriteLine("Položka s ID {0} nenalezena.", i);
            }
        }

        public static void delitemById()
        {
            Console.WriteLine("Zadejte ID položky kterou chcete smazat:");
            int i = toInt(Console.ReadLine());
            Item result = findById(i);
            if (result != null)
            {
                if (Program.items.Remove(result))
                {
                    Console.WriteLine("Položka {0} smazána.", result.ToString());
                }
            }
            else
            {
                Console.WriteLine("Položka s ID {0} nenalezena.", i);
            }
            
        }

        public static int toInt(String s)
        {
            int i = int.MinValue;
            try
            {
                i = Convert.ToInt32(s);
            }
            catch (FormatException e)
            {
                Console.WriteLine("Error: Input string is not a sequence of digits.");
            }
            catch (OverflowException e)
            {
                Console.WriteLine("Error: The number cannot fit in an Int32.");
            }
            return i;
        }

        public static Item findById(int id)
        {
            Item finded = Program.items.Find(
            delegate(Item item)
            {
                return item.ID == id;
            }
            );
            return finded;
        }

    }
}
