﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace invoice_manager
{
    delegate void fce();
    class MenuItem
    {
        public fce fce;
        public string desc;
    }

   

    class Program
    {
        public static List<Person> people = new List<Person>();
        //faktury přijaté
        public static List<Invoice> receivedInvoices = new List<Invoice>();
        //faktury vydané
        public static List<Invoice> issuedInvoices = new List<Invoice>();
        public static List<Item> items = new List<Item>();

        static void Main(string[] args)
        {
            //Databaze db = new Databaze(Properties.Settings.Default.invoiceConnectionString);
            //String result = db.Vypis("Select name From people Where surname='Novak'");
            //System.Console.WriteLine(result);
            //db.Operace("Update people Set name='Vojta' Where surname='Novak'");
            //result = db.Vypis("Select name From people Where surname='Novak'");
            //System.Console.WriteLine(result);
            //db.Close();

            Console.Title = "Invoice Manager";
            Console.WindowHeight = 35;
            Console.WindowWidth = 80;
            //barva textu
            Console.ForegroundColor = ConsoleColor.Green;
            //barva pozadí
            Console.BackgroundColor = ConsoleColor.Black;

            Console.WriteLine(DateTime.Today);

            DataLoader loader = new DataLoader();
            people.AddRange(loader.loadPeople("people.txt"));
            items.AddRange(loader.loadItems("items.txt"));
            issuedInvoices.AddRange(loader.loadInvoices("issuedInvoices.txt", people));
            receivedInvoices.AddRange(loader.loadInvoices("receivedInvoices.txt", people));

            Menu();
        }

        static void Menu()
        {
            Dictionary<char, MenuItem> menu = new Dictionary<char, MenuItem>();
            menu.Add('1', new MenuItem() { fce = new fce(PersonMenu.menu), desc = "Osoby" });
            menu.Add('2', new MenuItem() { fce = new fce(ItemMenu.menu), desc = "Položky na fakturu" });
            menu.Add('3', new MenuItem() { fce = new fce(IssuedMenu.menu), desc = "Faktury vydané" });
            menu.Add('4', new MenuItem() { fce = new fce(ReceivedMenu.menu), desc = "Faktury přijaté" });
            menu.Add('0', new MenuItem() { fce = new fce(Exit), desc = "Konec" });

            while (true)
            {
                foreach (KeyValuePair<char, MenuItem> polozka in menu)
                {
                    Console.WriteLine("[" + polozka.Key + "] - " + polozka.Value.desc);
                }
                string volba = Console.ReadLine();
                if (menu.ContainsKey(volba[0]))
                    menu[volba[0]].fce();
            }
        }

        public static void Return()
        {
            Menu();
        }

        public static void Exit()
        {
            Environment.Exit(0);
            DataExporter export = new DataExporter();
            export.savePeople("people.txt", people);
            export.saveItems("items.txt", items);
            export.saveInvoices("issuedInvoices.txt", issuedInvoices);
            export.saveInvoices("receivedInvoices.txt", receivedInvoices);

        }

    }

}
